<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout column align-center justify-center>
        <v-card width="90%">
            <v-card-title>
                <v-layout row class="fab-container">

                    <v-btn
                        color="green"
                        dark
                        small
                        absolute
                        top
                        left
                        fab
                        @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>

                </v-layout>
                <v-layout width="100%" align-start justify-center column>
                    <v-layout wrap min-width="100%">

                        <v-flex xs12 md6 sm6>
                            <v-text-field @change="setFilterSearch" v-model="filter.search"
                                          label="جست و جو با نام یا شماره تماس"></v-text-field>
                        </v-flex>

                        <v-flex xs12 md6 sm6>
                            <v-text-field  readonly class="mr-2" v-model="filter.selectedCity.name"
                                          label="شهر"></v-text-field>
                        </v-flex>
                    </v-layout>
                    <v-layout align-start justify-center class="ma-2" row>
                        <v-btn
                            color="green"
                            dark
                            small
                            top
                            center
                            @click="readData"
                        >
                            اعمال فیلتر ها
                        </v-btn>

                        <v-btn
                            color="error"
                            dark
                            small
                            top
                            center
                            @click="removeFilter"
                        >
                            حذف فیلتر ها
                        </v-btn>

                        <v-btn
                            color="error"
                            dark
                            small
                            top
                            center
                            @click="showSelectCityForFilter">
                            انتخاب شهر
                        </v-btn>
                    </v-layout>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-card class="mt-2" width="90%">
            <v-card-title>
                <v-layout column>
                    <v-data-table
                        :headers="headers"
                        :items="allData"
                        hide-actions
                    >
                        <template
                            slot="headerCell"
                            slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                            slot="items"
                            slot-scope="{ item }"
                        >
                            <td>{{ item.freight_name}}</td>
                            <td>{{ item.owner_first_name}}</td>
                            <td>{{ item.owner_last_name}}</td>
                            <td>{{ item.username}}</td>
                            <td>{{ item.owner_phone_number}}</td>
                            <td>{{ item.telephone_number}}</td>
                            <td>{{ item.credit}}</td>
                            <td>{{ item.point}}</td>
                            <td>{{ item.city.name}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                    small
                                    class="mr-2"
                                    @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                    small
                                    @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-form
                            ref="form"
                            v-model="valid"
                            lazy-validation
                        >
                            <v-layout wrap>

                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setFreightName"
                                                  v-model="selectedItem.freight_name"
                                                  label="نام باربری"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setFirstName"
                                                  v-model="selectedItem.owner_first_name"
                                                  label="نام صاحب باربری"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setLastName"
                                                  v-model="selectedItem.owner_last_name"
                                                  label="نام خانوادگی صاحب باربری"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" @change="setUserName"
                                                  v-model="selectedItem.username"
                                                  label="نام کاربری"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="phoneRules" type="number" @change="setPhoneNumber"
                                                  v-model="selectedItem.owner_phone_number"
                                                  label="شماره تلفن صاحب باربری"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="numberRules" type="number" @change="setPhoneNumber"
                                                  v-model="selectedItem.telephone_number"
                                                  label="شماره باربری"></v-text-field>
                                </v-flex>
                                <v-flex xs12 md4 sm4>
                                    <v-text-field @change="setPassword" v-model="selectedItem.new_password"
                                                  label="رمز عبور جدید"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-text-field :rules="nameRules" readonly v-model="selectedItem.city.name"
                                                  label="شهر"></v-text-field>
                                </v-flex>

                                <v-flex xs12 md4 sm4>
                                    <v-btn small class="mr-2" color="error" @click="showSelectCity">
                                        انتخاب شهر
                                    </v-btn>
                                </v-flex>


                            </v-layout>
                        </v-form>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
            v-model="DeleteDialog"
            width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این باربری را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
            v-model="WaitDialog"
            dark
            hide-overlay
            persistent
            width="300"
        >
            <v-card
                color="primary"
                dark
            >
                <v-card-text>
                    لطفا منتظر بمانید
                    <v-progress-linear
                        indeterminate
                        color="white"
                        class="mb-0"
                    ></v-progress-linear>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog v-model="selectCity" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                            <v-flex xs12 sm6 md6>
                                <v-select
                                    v-model="selectedProvince"
                                    :items="province"
                                    item-text="name"
                                    outlined
                                    label="استان را انتخاب کنید"
                                    single-line
                                    @change="getCity"
                                    return-object
                                ></v-select>
                            </v-flex>

                            <v-flex xs12 sm6 md6>

                                <v-progress-circular v-show="this.cityPending === true" indeterminate
                                                     color="blue"></v-progress-circular>
                                <v-select
                                    v-show="this.cityPending === false"
                                    v-model="selectedCity"
                                    :items="city"
                                    item-text="name"
                                    outlined
                                    label="شهر را انتخاب کنید"
                                    single-line
                                    @change="setSelectedCity"
                                    return-object
                                ></v-select>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideSelectCity">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="saveSelectedItemCity">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog v-model="selectCityForFilter" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>

                            <v-flex xs12 sm6 md6>
                                <v-select
                                    v-model="selectedProvince"
                                    :items="province"
                                    item-text="name"
                                    outlined
                                    label="استان را انتخاب کنید"
                                    single-line
                                    @change="getCity"
                                    return-object
                                ></v-select>
                            </v-flex>

                            <v-flex xs12 sm6 md6>

                                <v-progress-circular v-show="this.cityPending === true" indeterminate
                                                     color="blue"></v-progress-circular>
                                <v-select
                                    v-show="this.cityPending === false"
                                    v-model="filter.selectedCity"
                                    :items="city"
                                    item-text="name"
                                    outlined
                                    label="شهر را انتخاب کنید"
                                    single-line
                                    @change="setSelectedCityForFilter"
                                    return-object
                                ></v-select>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideSelectCityForFilter">بستن</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "carrier",
        methods: {
            ...mapMutations({
                setFreightName: 'carrier/setFreightName',
                setFirstName: 'carrier/setFirstName',
                setLastName: 'carrier/setLastName',
                setUserName: 'carrier/setUserName',
                setPhoneNumber: 'carrier/setPhoneNumber',
                setTelephoneNumber: 'carrier/setTelephoneNumber',
                setPassword: 'carrier/setPassword',
                setSelectedItem: 'carrier/setSelectedItem',
                showAddDialog: 'carrier/showAddDialog',
                hideAddDialog: 'carrier/hideAddDialog',
                showDeleteDialog: 'carrier/showDeleteDialog',
                hideDeleteDialog: 'carrier/hideDeleteDialog',
                showSelectCity: 'carrier/showSelectCity',
                hideSelectCity: 'carrier/hideSelectCity',
                showSelectCityForFilter: 'carrier/showSelectCityForFilter',
                hideSelectCityForFilter: 'carrier/hideSelectCityForFilter',
                showCityPending: 'carrier/showCityPending',
                hideCityPending: 'carrier/hideCityPending',
                setFilterSearch: 'carrier/setFilterSearch',
                setProvince: 'carrier/setProvince',
                setCity: 'carrier/setCity',
                setSelectedProvince: 'carrier/setSelectedProvince',
                setSelectedCity: 'carrier/setSelectedCity',
                setSelectedItemCity: 'carrier/setSelectedItemCity',
            }),
            ...mapActions({
                removeFilter: 'carrier/removeFilter',
                readData: 'carrier/readData',
                addOrEdit: 'carrier/addOrEdit',
                deleteOne: 'carrier/deleteOne',
                activate: 'carrier/activate',
                getCityByProvince: 'carrier/getCityByProvince',
                setSelectedCityForFilter: 'carrier/setSelectedCityForFilter',
            }),
            add() {
                this.setSelectedItem({
                    id: null,
                    freight_name: null,
                    owner_first_name: null,
                    owner_last_name: null,
                    username: null,
                    new_password: null,
                    owner_phone_number: null,
                    telephone_number: null,
                    status: null,
                    credit: null,
                    point: null,
                    marketer_id: null,
                    city_id: null,
                    city: {id: null, name: null}
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    freight_name: item.freight_name,
                    owner_first_name: item.owner_first_name,
                    owner_last_name: item.owner_last_name,
                    username: item.username,
                    new_password: item.new_password,
                    owner_phone_number: item.owner_phone_number,
                    telephone_number: item.telephone_number,
                    status: item.status,
                    credit: item.credit,
                    point: item.point,
                    marketer_id: item.marketer_id,
                    city_id: item.city_id,
                    city: item.city
                });
                this.showAddDialog();
            },
            add_Edit() {
                if (this.$refs.form.validate()) {
                    this.addOrEdit();
                }
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
            activateItem(item) {
                this.setSelectedItem(item);
                this.activate(item)
            },
            getCity(item) {
                console.log('item', item);
                this.setSelectedProvince(item);
                this.getCityByProvince();
            },
            saveSelectedItemCity() {
                this.setSelectedItemCity();
                this.hideSelectCity()
            },
        },
        computed: {

            ...mapState({
                allData: state => state.carrier.allData,
                AddDialog: state => state.carrier.AddDialog,
                DeleteDialog: state => state.carrier.DeleteDialog,
                selectedItem: state => state.carrier.selectedItem,
                pending: state => state.carrier.pending,
                allDataLoading: state => state.carrier.allDataLoading,
                WaitDialog: state => state.carrier.WaitDialog,
                selectCity: state => state.carrier.selectCity,
                province: state => state.carrier.province,
                city: state => state.carrier.city,
                selectedProvince: state => state.carrier.selectedProvince,
                selectedCity: state => state.carrier.selectedCity,
                selectCityForFilter: state => state.carrier.selectCityForFilter,
                cityPending: state => state.carrier.cityPending,
                filter: state => state.carrier.filter,

            }),
            selectedProvince: {
                set: function (value) {

                },
                get: function () {

                }
            },
            selectedCity: {
                set: function (value) {

                },
                get: function () {

                }
            }
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                valid: true,
                nameRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                    v => (!v || v.length >= 2) || 'حداقل باید 4 کاراکتر بنویسید',
                ],
                numberRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                phoneRules: [
                    v => !!v || 'شماره موبایل لازم است',
                    v => (!v || v.length === 11) || 'شماره موبایل لازم است 11 رقم باشد',
                ],
                headers: [
                    {text: 'نام', align: 'right', value: 'freight_name'},

                    {text: 'نام صاحب باربری', align: 'right', value: 'owner_first_name'},
                    {text: 'نام خانوادگی صاحب باربری', align: 'right', value: 'owner_last_name'},
                    {text: 'نام کاربری', align: 'right', value: 'username'},
                    {text: 'شماره تلفن صاحب باربری', align: 'right', value: 'owner_phone_number'},
                    {text: 'شماره باربری', align: 'right', value: 'telephone_number'},
                    {text: 'اعتبار', align: 'right', value: 'credit'},
                    {text: 'امتیاز', align: 'right', value: 'point'},
                    {text: 'شهر', align: 'right', value: 'city.name'},
                ],
            }
        },
    }
</script>
<style scoped>
    .layout {
        min-width: 100%;
    }
</style>
